﻿#pragma once

#include "..\..\DuiLib\UIlib.h"
#include "DuiDefine.h"
#include "..\DuiLib\Core\UIManager.h"

using namespace DuiLib;
using namespace std;
#define kMenuOptionMemo   _T("MenuOptionMemo")
#define kMenuOptionChatHistory   _T("MenuOptionChatHistory")
#define kMenuOptionMail  _T("MenuOptionMail")
#define kMenuOptionApprove _T("MemuOptionApprove")
#define kMenuOptionVOC	_T("MemuOptionVOC")
#define kMenuOptionSurvey _T("MenuOptionSurvey")
#define kMenuOptionIN	_T("MenuOptionIN")
#define kMenuOptionSAM	_T("MenuOptionSAM")
#define kMenuOptionAdd   _T("MenuOptionAdd")
#define kMenuArrowUp _T("MenuArrowUp")
#define kMenuArrowDown _T("MenuArrowDown")


typedef struct{
   int count;
   CString strURL;
   
}HANATOURBTNINFO;

class CMainMenuControler
{
public:
	CMainMenuControler(CPaintManagerUI* pPaintManger);
	virtual ~CMainMenuControler();

	bool InitFixedMenus();
	bool LoadActiveMenus();
	void SetLayout( CVerticalLayoutUI* pVetticalLayout );
	void DragStart(TNotifyUI& msg);
	void NotifySelectChange(TNotifyUI& msg, const CString& strLan);
	DWORD GetClipBoardFormat();
	CControlUI* HitTest(CPoint pt);

	void LineDown();
	void LineUp();
	DROPEFFECT	OnDragEnter(CWnd* , COleDataObject*  pDataObject,
		DWORD dwKeyState, CPoint );
	DROPEFFECT	OnDragOver(CWnd* pWnd , COleDataObject*  pDataObject,
		DWORD dwKeyState, CPoint point);

	DROPEFFECT	OnDragScroll(CWnd* pWnd, DWORD dwKeyState, CPoint point);
	BOOL		OnDrop(CWnd* , COleDataObject* pDataObject,
		DROPEFFECT dropEffect, CPoint point);
	void		OnDragLeave();
	void SetInfoItem(NTHanatourCountType eType, int nCount, CString strURL);
	int GetInfoItemCount(NTHanatourCountType eType);
	CString GetInfoItemURL(NTHanatourCountType eType);

protected:
	CMenuOptionUI* CreateMenu(LPCTSTR strImage, LPCTSTR strSelectImage, 
		LPCTSTR strSelectBKImage, LPCTSTR strText, LPCTSTR strSelectArrowImage);

	CButtonUI* CreateButton(LPCTSTR strBKImage, LPCTSTR strText,
		LPCTSTR strName, LPCTSTR strTooltip );
	
private:

	bool	_LoadMemoUI();
	bool	_LoadChatHistoryUI();
	bool	_LoadEmailUI();
	bool	_LoadApproveUI();
	bool	_LoadVOCUI();
	bool	_LoadSurveyUI();
	bool	_LoadINUI();
	bool	_LoadSAMUI();
	bool	_CheckAuth();
	bool	_SwapControl(CControlUI* pControlSource, CControlUI* pControlTarget);
	
	CPaintManagerUI*	m_pPaintManger;
	CVerticalLayoutUI*	m_pVetticalLayout;
	CControlUI*			m_pDargedControl;
	DWORD				m_uClipBoardFormat;
	vector<CControlUI*>  m_vecControls;
	CButtonUI* pButtonLineDown;
	CButtonUI* pButtonLineUp;
	std::map<NTHanatourCountType, HANATOURBTNINFO> m_mapHanatourBtnInfo;
};
